﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs)
        If Not Me.IsPostBack Then
            Me.BindDataList()
        End If
    End Sub

    Protected Sub SliderChanged(sender As Object, e As EventArgs) Handles Me.Load
        System.Threading.Thread.Sleep(2000) 'Added for testing and hence remove.
        Me.BindDataList()
    End Sub

    Private Sub BindDataList()
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Dim start As Integer = If(Not String.IsNullOrEmpty(Request.Form(hfStart.UniqueID)), Integer.Parse(Request.Form(hfStart.UniqueID)), 0)
        Dim [end] As Integer = If(Not String.IsNullOrEmpty(Request.Form(hfEnd.UniqueID)), Integer.Parse(Request.Form(hfEnd.UniqueID)), 0)
        lblSliderValue.Text = String.Format("Rs. {0} - Rs. {1}", start, [end])
        Using con As New SqlConnection(constr)
            Dim query As String = "SELECT * FROM Products WHERE (Price BETWEEN @Start AND @End) OR (@Start = 0 AND @End = 0);"
            query &= "SELECT MIN(Price) [Min], MAX(Price) [Max] FROM Products"
            Using cmd As New SqlCommand(query)
                cmd.Connection = con
                cmd.Parameters.AddWithValue("@Start", start)
                cmd.Parameters.AddWithValue("@End", [end])
                Using sda As New SqlDataAdapter(cmd)
                    Dim ds As New DataSet()
                    sda.Fill(ds)
                    dlProducts.DataSource = ds.Tables(0)
                    dlProducts.DataBind()
                    If Not Me.IsPostBack Then
                        hfStart.Value = ds.Tables(1).Rows(0)("Min").ToString()
                        hfEnd.Value = ds.Tables(1).Rows(0)("Max").ToString()
                        lblSliderValue.Text = String.Format("Rs. {0} - Rs. {1}", hfStart.Value, hfEnd.Value)
                    End If
                End Using
            End Using
        End Using
    End Sub
End Class
